// Definimos las variables globales
int y; // Número de iteraciones de la función draw()
float recorrido;
PVector iPos; // Posición inicial del ratón (cuando se clica)
PGraphics pg; // Creamos un contexto gráfico nuevo.
  
// Definimos las variables de ejecución 
void setup(){
 // Definimos la ventana del programa, la frecuencia de actualización y 
 // el color de fondo.
 size(600,600);
 frameRate(70);
 background(0);
  
 // Inicializamos las variables globales 
 y=0;
 recorrido=0;
 pg = createGraphics(600, 600);
 iPos = new PVector(0,0);
}
  
void draw()
{
 // Limpiamos la pantalla
 background(0);
 if (y>0)
 {
 // Dibujamos la trayectoria al contexto gráfico ps
 // Así la guardaremos para las próximas iteraciones
 pg.beginDraw(); // Empezamos a dibujar a ps 
 pg.stroke(255);
 // Añadimos la nueva línea al dibujo de la trayectoria
 pg.line(pmouseX, pmouseY, mouseX, mouseY); 
 pg.endDraw(); // Acabamos el dibujo de la nueva línea
 // Imprimimos a la pantalla el dibujo de la trayectoria
 image(pg, 0, 0);
  
 // Calculamos el recorrido
 recorrido = recorrido + sqrt((mouseX-pmouseX)*(mouseX-pmouseX)+
 (mouseY-pmouseY)*(mouseY-pmouseY));
  
 // Dibujamos el vector desplazamiento
 // Este queremos borrarlo cada vez que hacemos una iteración
 // por eso no utilizamos el contexto gráfico "pg"
 stroke(255, 0, 0);
 line(iPos.x,iPos.y, mouseX, mouseY);
 y++;
 }
 // Escribimos los resultados:
 // Dibujamos el background de la caja de texto.
fill(100, 100, 100);
 noStroke();
 rect(15, 480, 300, 60);
  
 // Escribimos la información del recorrido
 String str = "Recorrido (pixels): " + recorrido ;
fill(255, 255, 255);
 text( str, 20, 500); 
  
 // Escribimos la información del desplazamiento
 int aux1 = mouseX-int(iPos.x);
 int aux2 = mouseY-int(iPos.y);
 str = "Vector desplazamiento (pixels): (" + aux1 + "," + aux2 + ")";
fill(0,0,0);
 text( str, 20, 515);
  
 str = "Módulo vector desplazamiento (pixels): " + 
 sqrt((mouseX-iPos.x)*(mouseX-iPos.x) + (mouseY-iPos.y)*(mouseY-iPos.y));
fill(0,0,0);
 text( str, 20, 530);
}
  
void mouseClicked()
{
 // Esta función se llama cuando se clicka el ratón 
 background(0); // Borramos la pantalla
 // Borramos ps
 pg.beginDraw(); // Empezamos a dibujar a ps 
 pg.background(0);
 pg.endDraw(); // Acabamos el dibujo de la nueva línea
 // Imprimimos a la pantalla el dibujo de la trayectoria
 image(pg, 0, 0);
  
 y=1; // Inicializamos el contador y a 1
 // Inicializamos la posición inicial del desplazamiento
 iPos.x = mouseX;
 iPos.y = mouseY;
 recorrido = 0;
}
