PVector r, r0;
PVector v;
PVector a;
float R, T;
  
void setup()
{
 size(600, 600);
 frameRate(70);
  
 r = new PVector(R,0);
 r0 = new PVector(width/2, width/2);
  
 v = new PVector(0, 2*PI*R/T);
 a = new PVector(4*PI*PI*R*R/(T*T), 0);
  
 R = 100;
 T = 2;
}
  
void draw()
{
 // Cálculos
 /////////////////////////////////
 // Calculamos el instante de tiempo
 float t = millis()/1000.;
  
 // Calculamos la posición de la bola
 r.x = r0.x + R*cos(2*PI*t/T);
 r.y = r0.y + R*sin(2*PI*t/T);
  
 // Calculamos el vector velocidad
 v.x = -R*sin(2*PI*t/T);
 v.y = R*cos(2*PI*t/T);
  
 // Calculamos el vector aceleración
 a.x = -R*cos(2*PI*t/T);
 a.y = -R*sin(2*PI*t/T);

 // Dibujamos los resultados
 ///////////////////////////////// 
 background(0);
  
 // Dibujamos la trayectoria circular
fill(0);
 stroke(255);
 strokeWeight(1);
 ellipse(width/2, height/2, 2*R, 2*R);

 // Dibujamos la bola
fill(255);
 ellipse(r.x, r.y, 15, 15);
  
 // Dibujamos el vector velocidad
 strokeWeight(4);
 stroke(100, 100, 255);
 line(r.x, r.y, r.x+v.x, r.y+v.y);
 pinta_la_cabeza_de_flecha(int(r.x), int(r.y), int(r.x+v.x), int(r.y+v.y));
  
 // Dibujamos el vector aceleración
 stroke(120,6,23);
 line(r.x, r.y, r.x+a.x, r.y+a.y);
 pinta_la_cabeza_de_flecha(int(r.x), int(r.y), int(r.x+a.x), int(r.y+a.y));
}
  
void pinta_la_cabeza_de_flecha(int x1, int y1, int x2, int y2)
{
 float a = atan2(x1-x2, y2-y1); 
 pushMatrix();
 translate(x2, y2);
 rotate(a);
 line(0, 0, -10, -10);
 line(0, 0, 10, -10);
 popMatrix(); 
}
