// En este programa podéis ver el efecto de la masa y la fuerza aplicada
 // sobre la aceleración que logrará un cuerpo.
 // La idea es que la posición del ratón nos proporcione los valores de masa
 // y fuerza. Así, la coordenada Mouse.X será el valor de la masa mientras
 // que el valor de la coordenada Mouse.Y será el valor de la fuerza.

 //Empezamos definiendo las variables que necesitaremos

 PVector pos = new PVector(0,0); // Vector que utilizaremos para guardar la posición del ratón.
 int tempsi, tempsf; // Variables que nos permitirán seguir el paso del tiempo.

 void setup()
 {
   //Definimos la medida y color de la pantalla.
   size(600, 600);
   frameRate(70);
  
   background(0);

 //Inicializamos las variables.

   pos.x = 300;
   pos.y = 300;
  
   tempsi=millis();
 }

 void draw()
 {
   background(0);
  
    fill(255);
    textSize(20);
    text("Mueve el cursor a derecha e izquierda para variar la masa", 20, 100);
    text("Mueve el cursor arriba y abajo para variar la fuerza", 20, 130);
  
   // Para poder ir variando los valores de la masa y la fuerza,
   // hacemos que se lean a partir de la posición del Mouse.
   // Así, cuando movemos el ratón hacia la derecha, aumentaremos la fuerza aplicada
   // mientras que si lo movemos hacia arriba, aumentaremos la masa del cuerpo.
  
   float m = float(height - mouseY)/5;
   float F = float(width - mouseX)/100;
   float v = 0.;
    
   tempsf=millis();
  
   // Calculamos la aceleración del cuerpo a partir de la segunda ley de Newton
   // y la velocidad y posición a partir de las ecuaciones de cinemática.
  
   float a = F/m;     // Aplicamos aquí la segunda ley de Newton, F = m·a
  
   v = a*(tempsf-tempsi)/5; // Hemos dividido la velocidad por 5 por motivos "estéticos".
                            // La velocidad original tenía valores muy altos y el cuerpo se movía
                            // demasiado rápido por la pantalla. Al reducir la velocidad, podemos
                            // observar mejor el efecto de variar la masa y la fuerza.
  
   pos.x = pos.x + v * (tempsf-tempsi);
  
   // Corregimos la posición en el supuesto de que salga fuera de la ventana.
   int auxil = int(pos.x % width);
  
   // Dibujamos el cuerpo.
   fill(255, 255, 0);
   stroke(0);
   ellipse( auxil, pos.y, 25, 25);
  
   // Dibujamos el vector aceleración.
  
   stroke(255, 0, 0);
   strokeWeight(4);
   line(auxil, pos.y, auxil+1000*a, pos.y);
   line(auxil+1000*a, pos.y, (auxil+1000*a)-10, pos.y-10);
   line(auxil+1000*a, pos.y, (auxil+1000*a)-10, pos.y+10);
  
  
   // Imprimimos los datos.
  
   // Para evitar tener demasiados decimales, redondearemos los valores obtenidos.
   // Para hacerlo, utilizaremos la función nf, que permite escoger el número
   // de decimales que queremos dejar a un número:
  
   a=100*a;
   String n_a = nf(a, 2, 2);
   String n_F = nf(F, 1, 2);
  
   stroke(255);
   fill(125);
   rect(100, 400, 350, 100);
   String str1 = "Aceleración (m/s^2): " + n_a;
   String str2 = "Masa (Kg): " + m;
   String str3 = "Fuerza (N): " +n_F;
  
   fill(0);
   text(str1, 135, 425);
   text(str2, 135, 450);
   text(str3, 135, 475);
   tempsi=tempsf;
 }

   // Fijaos que los valores que obtenéis no tienen porque ser muy realistas.
   // El objetivo aquí era ver la diferencia en la aceleración final en función
   // de la massa del cuerpo y de la fuerza aplicada. A veces, si el objetivo es
   // apreciar un movimiento y estamos "condicionados" por el número de píxeles de la pantalla
   // tendremos que adaptar los valores de las magnitudes físicas para obtener un
   // resultado más visual. Fijaos que en este caso cogemos valores de coordenadas
   // (mouse.X y mouse.Y) como valores de fuerza y masa, entonces es normal que tengamos
   // que adaptar los valores numéricos para dar un aspecto más realista al
   // movimiento simulado.
