// Creamos aquí la clase CVibrPart2 para generar una onda que viaje en sentido contrario
// a la onda generada con la clase CVibrPart.

class CVibrPart2{
  // En esta parte del código definimos las variables propias, que definen cada una de las bolas de la animación.
  PVector p_pvIniPos; // Posición del centro de la oscilación de la partícula.
  
  float p_fAmpl; // Amplitud de la oscilación.
  float p_fFreq; // Frecuencia de la oscilación.
  
  float p_fPhase; // Desfase de la oscilación.
  
//Creamos el constructor.
  
  CVibrPart2(float x, float y, float fAmpl, float fFreq, float fPhase){
    p_pvIniPos = new PVector(0,0); // Generamos el vector que da la posición del centro de la vibración de la partícula.
    // Guardamos la posición x e y del centro de la vibración en el vector que hemos creado.
    p_pvIniPos.x = x; 
    p_pvIniPos.y = y;
    
    p_fAmpl = fAmpl; // Guardamos la amplitud.
    p_fPhase = fPhase; // La fase.
    p_fFreq = fFreq; // Y la frecuencia.

  }
  
// Creamos la función que devuelve el valor de la posición de la partícula.
  
  PVector pvOnaTransversal(float fT){
    
    PVector pvPos = new PVector(0,0); // Creamos un nuevo PVector, que será el que devolveremos con el resultado del cálculo.
    
    pvPos.x = p_pvIniPos.x; // La posición x de la particula no cambia en la vibración.
    pvPos.y = p_pvIniPos.y + p_fAmpl*sin(+fT*2*PI/p_fFreq + p_fPhase); // La posición y varía según se describe en un MOHS.
    
    // Fijaos que en este último paso hemos cambiado un signo para hacer que la onda viaje en dirección contraria.
    
    return pvPos;
  }
}
