// Esta es la definición de una clase que anomemen CVibrPart.
// Sigue una estructura muy parecida a la de la clase que ya conocéis CVibrPart.

class CInterPart{
// Definimos las variables propias, que definen cada una de las bolas de la animación.
  PVector n_pvIniPos; // Posición del centro de la oscilación de la partícula.
  
  float n_fAmpl1,n_fAmpl2; // Amplitud de la oscilación.
  float n_fFreq1,n_fFreq2; // Frecuencia de la oscilación.
  
  float n_fPhase1,n_fPhase2; // Desfase de la oscilación.
  
  // Creamos el constructor. Aquí necesitaremos utilizar la amplitud, fase y freqüencia de las dos ondas incidentes para
  // calcular su superposición.
  
  CInterPart(float x, float y, float fAmpl1, float fFreq1, float fPhase1, float fAmpl2, float fFreq2, float fPhase2 ){
    n_pvIniPos = new PVector(0,0);
    
    // Generamos el vector que da la posición del centro de la vibración de la partícula.
    // Guardamos la posición x e y del centro de la vibración en el vector que hemos creado.
    n_pvIniPos.x = x; 
    n_pvIniPos.y = y;
    
    n_fAmpl1 = fAmpl1; // Guardamos las amplitudes
    n_fAmpl2 = fAmpl2;
    n_fPhase1 = fPhase1; // Las fases.
    n_fPhase2 = fPhase2; 
    n_fFreq1 = fFreq1; // Y las frecuencias.
    n_fFreq2 = fFreq2;

  }
  
  PVector pvOnaTransversal(float fT){
    
    PVector pvPos = new PVector(0,0); // Creamos un nuevo PVector, que será el que devolveremos con el resultado del cálculo.
    
    pvPos.x = n_pvIniPos.x; // Mantenemos la posición x de la partícula.
    
    // Calculamos la posición final de la posición y a partir de la suma de la contribución de cada onda:
    
    pvPos.y = (n_pvIniPos.y + n_fAmpl1*sin(-fT*2*PI/n_fFreq1 + n_fPhase1))+(n_fAmpl2*sin(fT*2*PI/n_fFreq2 + n_fPhase2)); 
    
    return pvPos;
  }
}
