// Veremos en este programa la interferencia de dos ondas que 
// viajan en sentido contrario.

ArrayList<CVibrPart> ona1 = new ArrayList<CVibrPart>(); 
ArrayList<CVibrPart2> ona2 = new ArrayList<CVibrPart2>(); 
ArrayList<CInterPart> ona3 = new ArrayList<CInterPart>(); 


int iNum = 120; // Número de partículas.

void setup()
{
  size(630, 300); 

  for(int i = 0; i<iNum; i++){
    // Definimos las variables que necesitamos para generar una nueva partícula.
    int x = 5*(i+1); // La posición x inicial (las distribuimos a lo ancho de la pantalla).
    int y = 150; // La posición y inicial (las ponemos todas a la misma altura).
    float A = 50; // La amplitud de la vibración será de 50 píxeles.
    float phase = i*10*PI/180; // Definimos la fase entre las diferentes bolas. 
                               // Esta fase no es aleatoria, sino que depen de la posición de cada bola.
    float f = 3; // Definimos la frecuencia de la vibración (1Hz, o una oscilación por segundo).
      // Ahora creamos una nueva bola con estos parámetros.
    
    CVibrPart part1; // Definimos una partícula. 
     
    part1 = new CVibrPart(x, y, A , f, phase);
    
      ona1.add(part1); 
  }
  
  // Repetimos el proceso para la otra onda.
  
  for(int i = 0; i<iNum; i++){
    
    int x = 5*(i+1); 
    int y = 150; 
    float A = 50; 
    float phase = (i*10*PI/180)+150; 
    float f = 3; 
    
    CVibrPart2 part2; // Definimos una partícula. 
     
    part2 = new CVibrPart2(x, y, A , f, phase);
    
      ona2.add(part2); 
  }
  
  // Y finalmente la tercera onda.
  
   for(int i = 0; i<iNum; i++){
    
    int x = 5*(i+1); 
    int y = 150; 
    float A1 = 50; 
    float A2 = 50;
    
    float phase1 = i*10*PI/180;
    float phase2 = (i*10*PI/180)+150; // Introducimos la fase entre las diferentes bolas. 
                               // Esta fase no es aleatoria, sino que depen de la posición de cada bola
    float f1 = 3;
    float f2 = 3;  
    
    CInterPart part3; 
     
    part3 = new CInterPart(x, y, A1 , f1, phase1, A2, f2, phase2);
    
      ona3.add(part3); 
  }
 
}

void draw(){
  background(0); 
  float time = float(millis())/1000.; // Calculamos el instante de tiempo en el que nos encontramos, y lo ponemos en segundos.
  PVector pvPos1; // Creamos un vector que llenaremos con la posición que nos dé la clase CVibrPart
  for(int i = 0; i<iNum; i++){ // Repetimos el siguiente código para cada partícula en la colección (array) 'onda'.
      // Lo que haremos aquí será calcular la posición de cada partícula con la función 'pvOnaTransversal' de la clase 
      // 'CVibrPart'. Antes hemos llamado la función 'get' relacionada al objeto 'onda' escribiendo 'onda.get'
      // Ahora lo haremos de una manera parecida. Primero creamos una variable del tipo CVibrPart
    
    CVibrPart part1;
    
    // Ahora cogeremos la partícula y de la colección 'onda', utilizando la función 'get'
    // Lo hacemos igual que antes, con un punto:
    part1 = ona1.get(i); // Recuperamos la partícula que se encuentra a la posición 'y' de la colección 'onda'. 
    
    pvPos1 = part1.pvOnaTransversal(time); // Llamamos a la función 'pvOnaTransversal' del objeto 'part' que 
      // acabamos de extraer de 'onda'.
      // Esta función devuelve la posición en cada momento de una partícula que se mueve según un MOHS con las 
      // características con las que se creó
    
    fill(0,255,0); // Una vez calculada la posición, dibujamos un círculo  verde en aquella posición.
    stroke(0,255,0);
    ellipse(pvPos1.x, pvPos1.y, 5, 5); 
  }  
  
  // Creamos ahora la onda que viaja en sentido contrario utilizando la clase CVibrPart2.
  
  PVector pvPos2; 
  for(int i = 0; i<iNum; i++){ 
    
    CVibrPart2 part2;
    
   
    part2 = ona2.get(i); 
    
    pvPos2 = part2.pvOnaTransversal(time); 
    
    fill(0,0,255); // Una vez calculada la posición, dibujamos un círculo azul en aquella posición.
    stroke(0,0,255);
    ellipse(pvPos2.x, pvPos2.y, 5, 5); 
      
  }  
  
  // Finalmente creamos la tercera onda, interferencia de las otras dos:
  
  PVector pvPos3; // Creamos un vector que llenaremos con la posición que nos dé la clase CInterPart.
  for(int i = 0; i<iNum; i++){ 
    
    CInterPart part3;
    
    part3 = ona3.get(i);  
    
    pvPos3 = part3.pvOnaTransversal(time); 
    
    fill(255,0,0); // Una vez calculada la posición, dibujamos un círculo rojo en aquella posición.
    stroke(255,0,0);
    ellipse(pvPos3.x, pvPos3.y, 5, 5); 
      
  }  

}
