// En este programa escucharemos una nota tocada
// por diferentes instrumentos.

// Trabajaremos por primera vez con archivos externos. 
// Como cuando definiamos variables, en este caso  
// asignaremos un nombre de variable tipo "Audio" a cada
// fichero de sonido, de manera que se cargarán al inicio del 
// programa y estarán disponibles cuando los necesitemos.

Guitar = new Audio("guitar_A4.mp3");
Piano = new Audio("Piano_A4.mp3");
Organ = new Audio("Organ_A4.mp3");
Trumpet = new Audio("trumpet_A4.mp3");
Violin = new Audio("violin_A4.mp3");

void setup()
{
  size(600, 600);
  background(0);
  fill(255);
  textSize(20);
  text("Pulsa una tecla para oir la nota LA en diferentes instrumentos:", 40, 120);
  text("Pulsa p para oir un piano", 150, 200);
  text("Pulsa o per oir un órgano", 150, 240);
  text("Pulsa g per oir una guitarra", 150, 280);
  text("Pulsa t per oir una trompeta", 150, 320);
  text("Pulsa v per oir un violín", 150, 360);
  
}      

void draw()
{
  
  // Utilizaremos una función especial para conseguir diferentes acciones en función
  // de alguna condición. En este caso, la condición que utilizaremos será la tecla que 
  // pulsamos en el teclado. La función se llama "switch", y dentro de la función podremos  
  // definir las diferentes opciones.
  
  switch (key)  // key es una variable predefinida de processing que coge el valor de
                // la última tecla que hemos pulsado en el teclado. La utilizaremos como 
                // condición para entrar en las diferentes opciones.
  {
    case 'g':
      Guitar.play();
      key = '';  // Anulamos el valor de la variable key para dejarla libre.
      break;      // Detenemos la reproducción del sonido.
    case 't':
      Trumpet.play();
      key = '';
      break;
    case 'v':
      Violin.play();
      key = '';
      break;
    case 'p':
      Piano.play();
      key = '';
      break;
    case 'o':
      Organ.play();
      key = '';
      break;
    default:      // Condición per defecto. Sirve para evitar que el sonido se reproduzca
                  // de forma constante. 
      key='';
      break;
  }
}
