PGraphics histograma(PImage img)
// La función histograma calcula el histograma de una imagen y lo pinta en un objeto PGraphics.
{
 // Calcula el histograma
 img.loadPixels(); // Cargamos la información de los pixels de la imagen con la que estamos trabajando

 float[] hist = new float[256]; // Creamos un array de numeros float, donde guardaremos la información del histograma
  
 // Miramos cuál se el valor de la luminosidad o brillantez de cada pixel
 for (int y = 0; y < img.width; y++) // Por cada linia de la imagen
 {
 for (int j = 0; j < img.height; j++) // Por cada columna de la imagen
 {
 color bright = img.pixels[y*img.width + j]; // Extraem el color de cada pixel
 // Cómo que los pixels son todos en blanco y negro, 
 // la componente roja, azul y verde de cada pixel será igual.
 // La brillantez será cualquiera de las tres (porque son iguales).
 hist[int(red(bright))]++; // Un golpe tenemos la brillantez, podemos contar un pixel más con este valor de brillantez.
 }
 }
  
 float auxmax = max(hist);
  
 PGraphics pg = createGraphics(img.width, img.height);
 pg.beginDraw();
 pg.stroke(255, 0, 0);
 for(int b = 0; b<256; b++)
 {
 pg.line(b, img.height, b, (img.height-int(hist[b]*50/auxmax)));
 }
 pg.endDraw();
 return pg;
}