// Definimos las variables globales del programa
int radio; // Radio del espejo
int variacio; // Variacio de la altura del rayo incidente


void setup(){
 size(1200, 600);
 frameRate(70);
  
 radio = 400;
 variacio = 20;
}

void draw(){
 background(124, 204, 196);
  
 // Movemos el centro de coordenadas al centro de la circunferencia que define el espejo.
 translate(width, height/2);
  
 // Dibujamos el espejo esférico
 fill(255);
 noStroke();
 rect(-(width), -height/2, width, height);
 strokeWeight(2);
 stroke(0);
 fill(124, 204, 196);
 arc(0, 0, 2*radio, 2*radio, HALF_PI, PI+HALF_PI, PIE); // Debido a la traslación de antes, 
 // ahora el centro del espejo es al 
 // punto (0,0) 

  
 //ellipse(0,0,2*radio,2*radio);

 // Dibujamos el eje óptico
 stroke(0,0,0);
 line(-width, 0, width + radio, 0);
  
 // La animación hace que la altura del rayo varii alrededor del 0 con una función coseno 
 float y = -variacio*cos(map( (millis()/10)%360,0, 360, 0, 2*PI));
  
 // Calculamos en qué punto toca el rayo al espejo
 float x1 = -sqrt( radio*radio-y*y);
  
 //Ahora podemos dibujar el rayo incidente:
 stroke(255, 125, 125);
 line(-width, y, x1, y);
  
 // Dibujamos la normal (que es el radio del espejo que pasa por dondel rayo toca el espejo)
 stroke(125, 125, 255);
 line(0,0,-width,y*(width)/radio);
  
 // Dibujamos el rayo reflejado:
 stroke(255, 125, 125);
 float y2 = (width+x1)*tan(2*asin(y/radio));

 line(x1,y, -width, y+y2);
}

void keyPressed() 
{
 if (key == CODED) 
 {
 if (keyCode == UP) 
 {
 radio = radio + 50;
 if(radio>1200) radio=1200;
 } else if (keyCode == DOWN) 
 {
 radio = radio - 50;
 if(radio<100) radio=100;
 } 
 } 
} 
