// Definimos las variables globales del programa
int radio; // Radio del espejo
int variacion; // Variacio de la altura del rayo incidente
float n1, n2; // Indexs de refracción del primer medio y del segundo

void setup(){
 size(1200, 600);
 frameRate(70);
  
 radio = 1100;
 variacion = 65;
  
 n1=1; // El primer medio es el aire
 n2=1.5; // El segundo medio es vidrio
}

void draw(){
 background(124, 204, 196);
  
 // Movemos el centro de coordenadas al centro de la circunferencia que define el espejo.
 translate(width-radio, height/2);
  
 // Dibujamos el espejo esférico
fill(255);
 noStroke();
 rect(-(width-radio), -height/2, radio, height);
 strokeWeight(2);
 stroke(0);
 arc(0, 0, 2*radio, 2*radio, -HALF_PI, HALF_PI); // Debido a la traslación de antes, 
 // ahora el centro del espejo es al 
 // punto (0,0) 
  

 // Dibujamos el eje óptico
 stroke(0,0,0);
 line(-width, 0, width + radio, 0);
  
 // Dibujamos el centro del espejo
fill(0);
 text("C", -3, -20);
  
 // Dibujamos el foco del espejo
 text("F", (radio/2)-3, -20);
  
  
 // La animación hace que la altura del rayo varii alrededor del 0 con una función coseno 
 float y = -variacion*cos(map( (millis()/10)%360,0, 360, 0, 2*PI));
  
 // Calculamos en qué punto toca el rayo al espejo
 float x1 = sqrt( radio*radio-y*y);
  
 //Ahora podemos dibujar el rayo incidente:
 stroke(255, 125, 125);
 line(-width, y, x1, y);
  
 // Dibujamos la normal (que es el radio del espejo que pasa por dondel rayo toca el espejo)
 stroke(125, 125, 255);
 line(0,0,x1,y);
  
 // Dibujamos el rayo refractado:
 stroke(255, 125, 125);
 float x2 = y/tan(2*asin(y/radio));

 line(x1,y, x1-x2, 0);
}

void keyPressed() 
{
 if (key == CODED) 
 {
   if (keyCode == UP) 
    {
    radio = radio + 50;
    if(radio > 1200) radio = 1200;
    } else if (keyCode == DOWN)
    {
      radio = radio-50;
      if (radio < 600) radio = 600;
    }
    else if (keyCode == RIGHT)
    {
      variacion = variacion + 10;
      if (variacion > 205) variacion = 205;
    }
    else if (keyCode == LEFT)
    {
      variacion = variacion-10;
      if (variacion < 65) variacion = 65;
    }
  }
}
