float  n1, n2;
float t0;

boolean animado;


void setup() {
 size(512, 512);
 background(125);
 n1 = 1.; // Index de refracción del aire
 n2 = 1.33; // Index de refracción del agua
 animado = true;
 t0=millis();
}

void draw() { 
if(animado == true)
 {
 // Cálculos
 ////////////////////////////
 // Definimos el ángulo de incidencia
 float theta_inc = PI/4*(1 + sin((millis()-t0)*2*PI/4000)); // Hagamos que el ángulo de incidencia oscile en el tiempo entre 0 y PI/2
 float theta_refl = theta_inc; // Calculamos el ángulo de reflexión, qué es igual al de incidencia
 float theta_refr = asin((n1/n2)*sin(theta_inc)); // Calculamos el ángulo de refracción, utilizando la ley de Snell.

 // Pintamos la escena
 ////////////////////////
 background(255); // El fondo lo pintamos de blanco

 // Pintamos el medio de color azul
fill(124, 204, 196);
 noStroke();
 rect(0,256, 512, 256);

 // Pintamos la normal a la superficie del medio
 strokeWeight(1);
 stroke(126);
 line(256, 0, 256, width);

 // Pintamos los rayos:
 PVector finish = new PVector(0, 0);
 PVector start = new PVector(0, 0);

 // Rayo incidente (que llega al centro de la pantalla):
 // Calculamos el origen del rayo incidente
 finish.x = 256;
 finish.y = 256;
 start.x = finish.x - 256*sin(theta_inc);
 start.y = finish.y - 256*cos(theta_inc);
 // Pintamos el rayo incidente
 strokeWeight(3);
 stroke(256, 126, 126);
 line(start.x, start.y, finish.x, finish.y);
 pinta_la_cabeza_de_flecha(int(start.x), int(start.y), int(finish.x), int(finish.y));

 // Rayo reflejado (que sale del centro de la pantalla)
 // Calculamos el origen del rayo incidente
 start.x = 256;
 start.y = 256;
 finish.x = start.x + 256*sin(theta_refl);
 finish.y = start.y - 256*cos(theta_refl);
 // Pintamos el rayo incidente
 strokeWeight(3);
 stroke(256, 126, 126);
 line(start.x, start.y, finish.x, finish.y);
 pinta_la_cabeza_de_flecha(int(start.x), int(start.y), int(finish.x), int(finish.y));

 // Comprobamos el valor de theta_refr: Si es más grande de 90 (PI/2), se produce la reflexión total interna, y no hay rayo refractado.
 if(!Float.isNaN(theta_refr))
 {
 // Rayo refractado (que sale del centro de la pantalla)
 start.x = 256;
 start.y = 256;
 finish.x = start.x + 256*sin(theta_refr);
 finish.y = start.y + 256*cos(theta_refr);
 // Pintamos el rayo incidente
 strokeWeight(3);
 stroke(256, 126, 126);
 line(start.x, start.y, finish.x, finish.y);
 pinta_la_cabeza_de_flecha(int(start.x), int(start.y), int(finish.x), int(finish.y));
 }
  
 // Escribe los valores de n1 y n2
 textSize(20);
text("n1=" + n1, 10, 30);
fill(255);
text("n2=" + n2, 10, 480);
 }
}

void pinta_la_cabeza_de_flecha(int x1, int y1, int x2, int y2)
{
 float a = atan2(x1-x2, y2-y1); 
 pushMatrix();
 translate(x2, y2);
 rotate(a);
 line(0, 0, -10, -10);
 line(0, 0, 10, -10);
 popMatrix(); 
}
